'**********************************************************
' C-Control Station
'
' Beispiel - Treppenlichtautomat
'
' Im Treppenhaus sollen vier Tastschalter installiert sein,
' mit denen das Treppenlicht eingeschaltet wird.
'
' Station   Hauslichttasten
'
'  P1 <-_________/ ____
'           |          |
'           |____/ ____|
'           |          |
'           |____/ ____|
'           |          |
'           |____/ ____|
'                      |
'  GND <-______________|

' Das Hauslicht soll ueber Relais K1 geschaltet werden.
' Jedes Druecken auf eine der Tasten addiert
' 1 Minute auf die Leuchtdauer. Nach Ablauf der Leuchtdauer
' soll das Licht automatisch abschalten. ber die
' Folientaste F1 soll Dauerlicht im Treppenhaus
' ein- und ausgeschaltet werden koennen. Die LED1 zeigt den
' Dauerlichtzustand an.
'
' Das Kellerlicht haengt am Relais K2 und wird durch Druecken
' auf zwei weitere Taster ein- und ausgeschaltet.
'
' Station   Kellerlichttasten
'
'  P2 <-_________/ ____
'           |          |
'           |____/ ____|
'                      |
'  GND <-______________|
'
'**********************************************************

' die Digitalports
define hauslichtTasten port[1]
define kellerlichtTasten port[2]

' die Relais
define hauslichtRelais port[7]
define kellerlichtRelais port[8]

' Folientaste und LED
define dauerlichtTaste port[9]
define dauerlichtLED port[13]

' Variablen
define lichtausSekunde byte
define lichtausMinute byte


' Initialisierung
hauslichtRelais = OFF
kellerlichtRelais = OFF
dauerlichtLED = OFF


#loop

  if not hauslichtTasten then gosub lichtEin
  if (minute = lichtausMinute) and (second = lichtausSekunde) and not dauerlichtLED then hauslichtRelais = OFF

  if not dauerlichtTaste then gosub dauerlichtEinAus
  if not kellerlichtTasten then gosub kellerlichtEinAus

goto loop



#lichtEin
  if hauslichtRelais = OFF then lichtausMinute = minute
  lichtausMinute = (lichtausMinute + 1) mod 60
  lichtausSekunde = second
  hauslichtRelais = ON
  pause 5
  wait hauslichtTasten
return


#dauerlichtEinAus
  tog hauslichtRelais
  dauerlichtLED = hauslichtRelais
  pause 5
  wait dauerlichtTaste
return


#kellerlichtEinAus
  tog kellerlichtRelais
  pause 5
  wait kellerlichtTasten
return


